

Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/arch/i386/kernel/irq.c     |    4 +++-
 25-akpm/arch/i386/kernel/traps.c   |    3 +--
 25-akpm/include/asm-i386/hardirq.h |    3 +++
 3 files changed, 7 insertions(+), 3 deletions(-)

diff -puN arch/i386/kernel/irq.c~fix-of-stack-dump-in-soft-hardirqs-cleanup arch/i386/kernel/irq.c
--- 25/arch/i386/kernel/irq.c~fix-of-stack-dump-in-soft-hardirqs-cleanup	Fri Oct  1 15:05:24 2004
+++ 25-akpm/arch/i386/kernel/irq.c	Fri Oct  1 15:05:45 2004
@@ -10,12 +10,14 @@
  * io_apic.c.)
  */
 
-#include <asm/uaccess.h>
 #include <linux/module.h>
 #include <linux/seq_file.h>
 #include <linux/interrupt.h>
 #include <linux/kernel_stat.h>
 
+#include <asm/uaccess.h>
+#include <asm/hardirq.h>
+
 #ifdef CONFIG_4KSTACKS
 /*
  * per-CPU IRQ handling contexts (thread information and stack)
diff -puN arch/i386/kernel/traps.c~fix-of-stack-dump-in-soft-hardirqs-cleanup arch/i386/kernel/traps.c
--- 25/arch/i386/kernel/traps.c~fix-of-stack-dump-in-soft-hardirqs-cleanup	Fri Oct  1 15:05:24 2004
+++ 25-akpm/arch/i386/kernel/traps.c	Fri Oct  1 15:06:01 2004
@@ -50,6 +50,7 @@
 #include <asm/smp.h>
 #include <asm/arch_hooks.h>
 #include <asm/kdebug.h>
+#include <asm/hardirq.h>
 
 #include <linux/irq.h>
 #include <linux/module.h>
@@ -107,8 +108,6 @@ int register_die_notifier(struct notifie
 
 static int valid_stack_ptr(struct task_struct *task, void *p)
 {
-	extern int is_irq_stack_ptr(struct task_struct *, void *);
-
 	if (is_irq_stack_ptr(task, p))
 		return 1;
 	if (p >= (void *)task->thread_info &&
diff -puN include/asm-i386/hardirq.h~fix-of-stack-dump-in-soft-hardirqs-cleanup include/asm-i386/hardirq.h
--- 25/include/asm-i386/hardirq.h~fix-of-stack-dump-in-soft-hardirqs-cleanup	Fri Oct  1 15:05:24 2004
+++ 25-akpm/include/asm-i386/hardirq.h	Fri Oct  1 15:06:29 2004
@@ -36,4 +36,7 @@ static inline void ack_bad_irq(unsigned 
 #endif
 }
 
+struct task_struct;
+int is_irq_stack_ptr(struct task_struct *task, void *p);
+
 #endif /* __ASM_HARDIRQ_H */
_
